diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelFactsImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelFactsImport.java
index 2365f13629..5da0f9dbe8 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelFactsImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelFactsImport.java
@@ -27,6 +27,7 @@ import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
 import eu.etaxonomy.cdm.common.media.ImageInfo;
+import eu.etaxonomy.cdm.database.update.DatabaseTypeNotSupportedException;
 import eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer;
 import eu.etaxonomy.cdm.io.berlinModel.in.validation.BerlinModelFactsImportValidator;
 import eu.etaxonomy.cdm.io.common.IOValidator;
@@ -35,12 +36,13 @@ import eu.etaxonomy.cdm.io.common.Source;
 import eu.etaxonomy.cdm.io.common.mapping.UndefinedTransformerMethodException;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.Marker;
 import eu.etaxonomy.cdm.model.common.MarkerType;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementSource;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
@@ -85,7 +87,7 @@ public class BerlinModelFactsImport  extends BerlinModelImportBase {
 			return featureVocabulary;
 		} catch (UnknownCdmTypeException e) {
 			logger.error("Feature vocabulary not available. New vocabulary created");
-			return TermVocabulary.NewInstance("User Defined Feature Vocabulary", "User Defined Feature Vocabulary", null, null); 
+			return TermVocabulary.NewInstance(TermType.Feature, "User Defined Feature Vocabulary", "User Defined Feature Vocabulary", null, null); 
 		}
 	}
 	
@@ -201,7 +203,7 @@ public class BerlinModelFactsImport  extends BerlinModelImportBase {
 			}else{
 				result = " ORDER By Fact.FactId";
 			}
-		} catch (NoSuchMethodException e) {
+		} catch (DatabaseTypeNotSupportedException e) {
 			logger.info("checkColumnExists not supported");
 			result = " ORDER By Fact.FactId";
 		}
@@ -305,7 +307,7 @@ public class BerlinModelFactsImport  extends BerlinModelImportBase {
 						}
 						
 						//reference
-						Reference citation = null;
+						Reference<?> citation = null;
 						String factRefFk = String.valueOf(factRefFkObj);
 						if (factRefFkObj != null){
 							citation = getReferenceOnlyFromMaps(biblioRefMap, nomRefMap, factRefFk);	
@@ -314,10 +316,8 @@ public class BerlinModelFactsImport  extends BerlinModelImportBase {
 								logger.warn("Citation not found in referenceMap: " + factRefFk);
 							success = false;
 							}
-						if (citation != null || CdmUtils.isNotEmpty(details)){
-							DescriptionElementSource originalSource = DescriptionElementSource.NewInstance();
-							originalSource.setCitation(citation);
-							originalSource.setCitationMicroReference(details);
+						if (citation != null || StringUtils.isNotBlank(details)){
+							DescriptionElementSource originalSource = DescriptionElementSource.NewPrimarySourceInstance(citation, details);
 							textData.addSource(originalSource);
 						}
 						taxonDescription.addElement(textData);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportBase.java
index a1758d9a3f..d842af4dd9 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportBase.java
@@ -23,6 +23,7 @@ import eu.etaxonomy.cdm.io.common.DbImportBase;
 import eu.etaxonomy.cdm.io.common.ICdmIO;
 import eu.etaxonomy.cdm.io.common.IImportConfigurator.EDITOR;
 import eu.etaxonomy.cdm.io.common.IPartitionedIO;
+import eu.etaxonomy.cdm.io.common.TdwgAreaProvider;
 import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
@@ -32,8 +33,7 @@ import eu.etaxonomy.cdm.model.common.User;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.reference.Reference;
@@ -296,15 +296,15 @@ public abstract class BerlinModelImportBase extends DbImportBase<BerlinModelImpo
 		if ("EM".equals(em)){
 			return getNamedArea(state, BerlinModelTransformer.euroMedUuid, "Euro+Med", "Euro+Med area", "EM", null, null);
 		}else if("Rf".equals(em)){
-			return WaterbodyOrCountry.RUSSIANFEDERATION();
+			return Country.RUSSIANFEDERATION();
 		
 		}else if("KRY-OO;UKR-UK".equals(tdwg)){
-			return WaterbodyOrCountry.UKRAINE();
+			return Country.UKRAINE();
 		
 		}else if("TCS-AZ;TCS-NA".equals(tdwg)){
-			return WaterbodyOrCountry.AZERBAIJANREPUBLICOF();
+			return Country.AZERBAIJANREPUBLICOF();
 		}else if("TCS-AB;TCS-AD;TCS-GR".equals(tdwg)){
-			return WaterbodyOrCountry.GEORGIA();
+			return Country.GEORGIA();
 		
 		
 		}else if("Cc".equals(em)){
@@ -313,13 +313,13 @@ public abstract class BerlinModelImportBase extends DbImportBase<BerlinModelImpo
 		
 		//E+M
 		else if("EUR".equals(em)){
-			return TdwgArea.getAreaByTdwgAbbreviation("1");
+			return TdwgAreaProvider.getAreaByTdwgAbbreviation("1");
 		}else if("14".equals(em)){
-			return TdwgArea.getAreaByTdwgAbbreviation("14");
+			return TdwgAreaProvider.getAreaByTdwgAbbreviation("14");
 		}else if("21".equals(em)){
-			return TdwgArea.getAreaByTdwgAbbreviation("21");  // Macaronesia
+			return TdwgAreaProvider.getAreaByTdwgAbbreviation("21");  // Macaronesia
 		}else if("33".equals(em)){
-			return TdwgArea.getAreaByTdwgAbbreviation("33");
+			return TdwgAreaProvider.getAreaByTdwgAbbreviation("33");
 		
 		}else if("SM".equals(em)){
 			return getNamedArea(state, BerlinModelTransformer.uuidSerbiaMontenegro, "Serbia & Montenegro", "Euro+Med area 'Serbia & Montenegro'", "SM", NamedAreaType.ADMINISTRATION_AREA(), null);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportConfigurator.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportConfigurator.java
index 51b36302ea..0deb419509 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportConfigurator.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelImportConfigurator.java
@@ -152,7 +152,7 @@ public class BerlinModelImportConfigurator extends DbImportConfiguratorBase<Berl
 	 * @param destination
 	 */
 	protected BerlinModelImportConfigurator(Source berlinModelSource, ICdmDataSource destination) {
-	   super(berlinModelSource, destination, NomenclaturalCode.ICBN, defaultTransformer); //default for Berlin Model
+	   super(berlinModelSource, destination, NomenclaturalCode.ICNAFP, defaultTransformer); //default for Berlin Model
 	}
 	
 	
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelNameFactsImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelNameFactsImport.java
index 5b26a8e852..92bebaa9a2 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelNameFactsImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelNameFactsImport.java
@@ -39,6 +39,7 @@ import eu.etaxonomy.cdm.io.common.ResultSetPartitioner;
 import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
@@ -133,9 +134,9 @@ public class BerlinModelNameFactsImport  extends BerlinModelImportBase  {
 				String category = CdmUtils.Nz(rs.getString("NameFactCategory"));
 				String nameFact = CdmUtils.Nz(rs.getString("nameFact"));
 				
-				TaxonNameBase taxonNameBase = nameMap.get(String.valueOf(nameId));
+				TaxonNameBase<?,?> taxonNameBase = nameMap.get(String.valueOf(nameId));
 				String nameFactRefFk = String.valueOf(nameFactRefFkObj);
-				Reference citation = getReferenceOnlyFromMaps(biblioRefMap, 
+				Reference<?> citation = getReferenceOnlyFromMaps(biblioRefMap, 
 						nomRefMap, nameFactRefFk);
 				
 				if (taxonNameBase != null){
@@ -149,12 +150,12 @@ public class BerlinModelNameFactsImport  extends BerlinModelImportBase  {
 								TaxonNameDescription description = TaxonNameDescription.NewInstance();
 								TextData protolog = TextData.NewInstance(Feature.PROTOLOGUE());
 								protolog.addMedia(media);
-								protolog.addSource(String.valueOf(nameFactId), NAMESPACE, null, null, null, null);
+								protolog.addSource(OriginalSourceType.Import, String.valueOf(nameFactId), NAMESPACE, null, null, null, null);
 								description.addElement(protolog);
 								taxonNameBase.addDescription(description);
 								if (citation != null){
-									description.addSource(null, null, citation, null);
-									protolog.addSource(null, null, citation, nameFactRefDetail, null, null);
+									description.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, null);
+									protolog.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, nameFactRefDetail, null, null);
 								}
 							}//end NAME_FACT_PROTOLOGUE
 						}catch(NullPointerException e){
@@ -168,8 +169,10 @@ public class BerlinModelNameFactsImport  extends BerlinModelImportBase  {
 							//TODO language
 							Language language = Language.DEFAULT();
 							additionalPublication.putText(language, nameFact);
-							additionalPublication.addSource(String.valueOf(nameFactId), NAMESPACE, citation, 
-									nameFactRefDetail, null, null);
+							additionalPublication.addSource(OriginalSourceType.Import, String.valueOf(nameFactId), NAMESPACE, null,null, null, null);
+							if (citation != null || isNotBlank(nameFactRefDetail)){
+								additionalPublication.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, nameFactRefDetail, null, null);
+							}
 							description.addElement(additionalPublication);
 							taxonNameBase.addDescription(description);
 						}
@@ -180,8 +183,10 @@ public class BerlinModelNameFactsImport  extends BerlinModelImportBase  {
 							//TODO language
 							Language language = Language.DEFAULT();
 							bibliography.putText(language, nameFact);
-							bibliography.addSource(String.valueOf(nameFactId), NAMESPACE, citation, 
-									nameFactRefDetail, null, null);
+							bibliography.addSource(OriginalSourceType.Import, String.valueOf(nameFactId), NAMESPACE, null,null, null, null);
+							if (citation != null || isNotBlank(nameFactRefDetail)){
+								bibliography.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, nameFactRefDetail, null, null);
+							}
 							description.addElement(bibliography);
 							taxonNameBase.addDescription(description);
 						}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceImport.java
index 45a0f19ac1..9cf37f962b 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceImport.java
@@ -28,6 +28,7 @@ import eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer;
 import eu.etaxonomy.cdm.io.berlinModel.in.validation.BerlinModelOccurrenceImportValidator;
 import eu.etaxonomy.cdm.io.common.IOValidator;
 import eu.etaxonomy.cdm.io.common.ResultSetPartitioner;
+import eu.etaxonomy.cdm.io.common.TdwgAreaProvider;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
 import eu.etaxonomy.cdm.model.common.CdmBase;
@@ -38,7 +39,6 @@ import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
@@ -152,7 +152,7 @@ public class BerlinModelOccurrenceImport  extends BerlinModelImportBase {
 						}
 						
 						for (String tdwgCode : tdwgCodes){
-							NamedArea area = TdwgArea.getAreaByTdwgAbbreviation(tdwgCode.trim());
+							NamedArea area = TdwgAreaProvider.getAreaByTdwgAbbreviation(tdwgCode.trim());
 				        	if (area == null){
 				        		area = getOtherAreas(state, emCodeString, tdwgCodeString);
 				        	}
@@ -188,7 +188,7 @@ public class BerlinModelOccurrenceImport  extends BerlinModelImportBase {
                         	   Distribution duplicate = checkIsNoDuplicate(taxonDescription, distribution, duplicateMap , occurrenceId);
                                if (duplicate == null){
 	                        	   taxonDescription.addElement(distribution); 
-	                               distribution.addSource(String.valueOf(occurrenceId), NAMESPACE, state.getTransactionalSourceReference(), null);
+	                               distribution.addImportSource(String.valueOf(occurrenceId), NAMESPACE, state.getTransactionalSourceReference(), null);
 	                        	   countDistributions++; 
 	                               if (taxonDescription != oldDescription){ 
 	                            	   taxaToSave.add(taxonDescription.getTaxon()); 
@@ -197,7 +197,7 @@ public class BerlinModelOccurrenceImport  extends BerlinModelImportBase {
 	                               	} 
                                }else{                          	  
                             	   countDuplicates++;
-                            	   duplicate.addSource(String.valueOf(occurrenceId), NAMESPACE, state.getTransactionalSourceReference(), null);
+                            	   duplicate.addImportSource(String.valueOf(occurrenceId), NAMESPACE, state.getTransactionalSourceReference(), null);
                             	   logger.info("Distribution is duplicate");	                           }
 	                       	} else { 
 	                       		logger.warn("Distribution " + area.getLabel() + " ignored. OccurrenceId = " + occurrenceId);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceSourceImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceSourceImport.java
index 6da239a0dc..8d3d694c0a 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceSourceImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelOccurrenceSourceImport.java
@@ -27,8 +27,9 @@ import eu.etaxonomy.cdm.io.common.IOValidator;
 import eu.etaxonomy.cdm.io.common.ResultSetPartitioner;
 import eu.etaxonomy.cdm.io.common.Source;
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementSource;
 import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
@@ -134,13 +135,13 @@ public class BerlinModelOccurrenceSourceImport  extends BerlinModelImportBase {
     				Reference<?> ref = getReference(refId, state);
 
     				if (ref != null){
-    					DescriptionElementSource originalSource = DescriptionElementSource.NewInstance();
+    					DescriptionElementSource originalSource = DescriptionElementSource.NewInstance(OriginalSourceType.PrimaryTaxonomicSource);
     					originalSource.setCitation(ref);
     					TaxonNameBase<?, ?> taxonName;
 						taxonName = getName(state, oldName, oldNameFk);
 						if (taxonName != null){
     						originalSource.setNameUsedInSource(taxonName);
-    					}else if(CdmUtils.isNotEmpty(oldName)){
+    					}else if(isNotBlank(oldName)){
     						originalSource.setOriginalNameString(oldName);
     					}
     					distribution.addSource(originalSource);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelReferenceImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelReferenceImport.java
index 8bc1b7f43f..589a205e7e 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelReferenceImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelReferenceImport.java
@@ -20,9 +20,6 @@ import static eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer.REF_PART_OF
 import static eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer.REF_PRINT_SERIES;
 import static eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer.REF_UNKNOWN;
 import static eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer.REF_WEBSITE;
-import static eu.etaxonomy.cdm.io.common.IImportConfigurator.DO_REFERENCES.ALL;
-import static eu.etaxonomy.cdm.io.common.IImportConfigurator.DO_REFERENCES.CONCEPT_REFERENCES;
-import static eu.etaxonomy.cdm.io.common.IImportConfigurator.DO_REFERENCES.NOMENCLATURAL;
 import static eu.etaxonomy.cdm.io.common.ImportHelper.NO_OVERWRITE;
 import static eu.etaxonomy.cdm.io.common.ImportHelper.OBLIGATORY;
 import static eu.etaxonomy.cdm.io.common.ImportHelper.OVERWRITE;
@@ -67,9 +64,7 @@ import eu.etaxonomy.cdm.model.common.IdentifiableSource;
 import eu.etaxonomy.cdm.model.common.Marker;
 import eu.etaxonomy.cdm.model.common.MarkerType;
 import eu.etaxonomy.cdm.model.reference.IArticle;
-import eu.etaxonomy.cdm.model.reference.IBook;
 import eu.etaxonomy.cdm.model.reference.IBookSection;
-import eu.etaxonomy.cdm.model.reference.IJournal;
 import eu.etaxonomy.cdm.model.reference.IPrintSeries;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
@@ -511,8 +506,8 @@ public class BerlinModelReferenceImport extends BerlinModelImportBase {
 			
 			//idInSource
 			String idInSource = (String)valueMap.get("IdInSource".toLowerCase());
-			if (CdmUtils.isNotEmpty(idInSource)){
-				IdentifiableSource source = IdentifiableSource.NewInstance(idInSource);
+			if (isNotBlank(idInSource)){
+				IdentifiableSource source = IdentifiableSource.NewDataImportInstance(idInSource);
 				source.setIdNamespace("import to Berlin Model");
 				referenceBase.addSource(source);
 			}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonImport.java
index 09d9bed9b5..c7b0ba3cc7 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonImport.java
@@ -28,6 +28,7 @@ import org.apache.log4j.Logger;
 import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.database.update.DatabaseTypeNotSupportedException;
 import eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer;
 import eu.etaxonomy.cdm.io.berlinModel.in.validation.BerlinModelTaxonImportValidator;
 import eu.etaxonomy.cdm.io.common.IOValidator;
@@ -293,7 +294,7 @@ public class BerlinModelTaxonImport  extends BerlinModelImportBase {
 		} catch (SQLException e) {
 			logger.error("SQLException:" +  e);
 			return false;
-		} catch (NoSuchMethodException e) {
+		} catch (DatabaseTypeNotSupportedException e) {
 			logger.error("MethodNotSupportedException:" +  e);
 			return false;
 		}
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonNameImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonNameImport.java
index 07e12a362b..0a34119f7d 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonNameImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonNameImport.java
@@ -22,6 +22,7 @@ import org.apache.log4j.Logger;
 import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.database.update.DatabaseTypeNotSupportedException;
 import eu.etaxonomy.cdm.io.berlinModel.BerlinModelTransformer;
 import eu.etaxonomy.cdm.io.berlinModel.in.validation.BerlinModelTaxonNameImportValidator;
 import eu.etaxonomy.cdm.io.common.IImportConfigurator;
@@ -36,7 +37,6 @@ import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.common.OrderedTermVocabulary;
 import eu.etaxonomy.cdm.model.common.Representation;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.CultivarPlantName;
@@ -191,12 +191,12 @@ public class BerlinModelTaxonNameImport extends BerlinModelImportBase {
 					}
 					
 					//create TaxonNameBase
-					TaxonNameBase taxonNameBase;
+					TaxonNameBase<?,?> taxonNameBase;
 					if (config.getNomenclaturalCode() != null){
 						taxonNameBase = config.getNomenclaturalCode().getNewTaxonNameInstance(rank);
 						//check cultivar
 						if (taxonNameBase instanceof BotanicalName){
-							if (CdmUtils.isNotEmpty(strCultivarGroupName) && CdmUtils.isNotEmpty(strCultivarName)){
+							if (isNotBlank(strCultivarGroupName) && isNotBlank(strCultivarName)){
 								taxonNameBase = CultivarPlantName.NewInstance(rank);
 							}
 						}
@@ -248,7 +248,7 @@ public class BerlinModelTaxonNameImport extends BerlinModelImportBase {
 					boolean colExists = true;
 					try {
 						colExists = state.getConfig().getSource().checkColumnExists("Name", "Source_Acc");
-					} catch (NoSuchMethodException e) {
+					} catch (DatabaseTypeNotSupportedException e) {
 						logger.debug("Source does not support 'checkColumnExists'");
 					}
 					if (colExists){
@@ -330,13 +330,13 @@ public class BerlinModelTaxonNameImport extends BerlinModelImportBase {
 	private Rank handleProlesAndRaceSublusus(BerlinModelImportState state, ResultSet rs, Rank rank) throws SQLException {
 		Rank result;
 		String rankAbbrev = rs.getString("RankAbbrev");
-		String rankStr = rs.getString("Rank");
+//		String rankStr = rs.getString("Rank");
 		if (CdmUtils.nullSafeEqual(rankAbbrev, "prol.") ){
-			result = getRank(state, BerlinModelTransformer.uuidRankProles, rankStr, "Rank Proles", rankAbbrev, CdmBase.deproxy(Rank.SPECIES().getVocabulary(), OrderedTermVocabulary.class), Rank.CONVAR());
+			result = Rank.PROLES();
 		}else if(CdmUtils.nullSafeEqual(rankAbbrev, "race")){
-			result = getRank(state, BerlinModelTransformer.uuidRankRace, rankStr, "Rank Race", rankAbbrev, CdmBase.deproxy(Rank.SPECIES().getVocabulary(), OrderedTermVocabulary.class), Rank.CONVAR());
+			result = Rank.RACE();
 		}else if(CdmUtils.nullSafeEqual(rankAbbrev, "sublusus")){
-			result = getRank(state, BerlinModelTransformer.uuidRankSublusus, rankStr, "Rank Sublusus", rankAbbrev, CdmBase.deproxy(Rank.SPECIES().getVocabulary(), OrderedTermVocabulary.class), Rank.CONVAR());
+			result = Rank.SUBLUSUS();
 		}else{
 			result = rank;
 			logger.warn("Unhandled rank: " + rankAbbrev);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonRelationImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonRelationImport.java
index 2d25a9f790..364f63df9e 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonRelationImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTaxonRelationImport.java
@@ -126,7 +126,7 @@ public class BerlinModelTaxonRelationImport  extends BerlinModelImportBase  {
 					if (i == 1 && state.getConfig().getClassificationUuid() != null){
 						tree.setUuid(state.getConfig().getClassificationUuid());
 					}
-					IdentifiableSource identifiableSource = IdentifiableSource.NewInstance(ptRefFk, TREE_NAMESPACE);
+					IdentifiableSource identifiableSource = IdentifiableSource.NewDataImportInstance(ptRefFk, TREE_NAMESPACE);
 					tree.addSource(identifiableSource);
 					
 					getClassificationService().save(tree);
@@ -394,7 +394,7 @@ public class BerlinModelTaxonRelationImport  extends BerlinModelImportBase  {
 			return;
 		}else{
 			Classification classification = getClassificationTree(state, classificationMap, secRefFk);
-			classification.addChildTaxon(taxon, null, null, null);
+			classification.addChildTaxon(taxon, null, null);
 		}
 		
 
@@ -445,7 +445,7 @@ public class BerlinModelTaxonRelationImport  extends BerlinModelImportBase  {
 				Classification classification = getClassificationTree(state, classificationMap, treeRefFk);
 				TaxonBase<?> taxon = taxonMap.get(taxonId);
 				if (taxon.isInstanceOf(Taxon.class)){
-					classification.addChildTaxon(CdmBase.deproxy(taxon, Taxon.class), null, null, null);
+					classification.addChildTaxon(CdmBase.deproxy(taxon, Taxon.class), null, null);
 				}else{
 					String message = "TaxonBase for taxon is not of class Taxon but %s (RIdentifier %s)";
 					logger.warn(String.format(message, taxon.getClass(), taxonId));
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTypesImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTypesImport.java
index 8262c2eac6..d8e1c78988 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTypesImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/BerlinModelTypesImport.java
@@ -30,12 +30,15 @@ import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.description.SpecimenDescription;
+import eu.etaxonomy.cdm.model.description.TextData;
 import eu.etaxonomy.cdm.model.media.ImageFile;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
 
@@ -77,7 +80,7 @@ public class BerlinModelTypesImport extends BerlinModelImportBase /*implements I
 	public boolean doPartition(ResultSetPartitioner partitioner, BerlinModelImportState state) {
 		boolean result = true;
 		Set<TaxonNameBase> namesToSave = new HashSet<TaxonNameBase>();
-		Map<Integer, Specimen> typeMap = new HashMap<Integer, Specimen>();
+		Map<Integer, DerivedUnit> typeMap = new HashMap<Integer, DerivedUnit>();
 		
 		Map<String, TaxonNameBase> nameMap = (Map<String, TaxonNameBase>) partitioner.getObjectMap(BerlinModelTaxonNameImport.NAMESPACE);
 		Map<String, Reference> biblioRefMap = partitioner.getObjectMap(BerlinModelReferenceImport.BIBLIO_REFERENCE_NAMESPACE);
@@ -126,7 +129,7 @@ public class BerlinModelTypesImport extends BerlinModelImportBase /*implements I
 							citation = getReferenceOnlyFromMaps(biblioRefMap, nomRefMap, relRefFk);
 							}
 						
-						Specimen specimen = Specimen.NewInstance();
+						DerivedUnit specimen = DerivedUnit.NewPreservedSpecimenInstance();
 						specimen.putDefinition(Language.DEFAULT(), typePhrase);
 						
 						if (typePhrase == null){
@@ -215,7 +218,7 @@ public class BerlinModelTypesImport extends BerlinModelImportBase /*implements I
 	}
 
 	
-	private static boolean makeFigures(Map<Integer, Specimen> typeMap, Source source){
+	private boolean makeFigures(Map<Integer, DerivedUnit> typeMap, Source source){
 		boolean success = true;
 		try {
 			//get data from database
@@ -245,9 +248,15 @@ public class BerlinModelTypesImport extends BerlinModelImportBase /*implements I
 				if (figurePhrase != null) {
 					media.addAnnotation(Annotation.NewDefaultLanguageInstance(figurePhrase));
 				}
-				Specimen typeSpecimen = typeMap.get(typeDesignationFk);
+				DerivedUnit typeSpecimen = typeMap.get(typeDesignationFk);
 				if (typeSpecimen != null) {
-					typeSpecimen.addMedia(media);
+					SpecimenDescription desc = this.getSpecimenDescription(typeSpecimen, IMAGE_GALLERY, CREATE);
+					if (desc.getElements().isEmpty()){
+						desc.addElement(TextData.NewInstance(Feature.IMAGE()));
+					}
+					TextData textData = (TextData)CdmBase.deproxy(desc.getElements().iterator().next(), TextData.class);
+					textData.addMedia(media);
+//					typeSpecimen.addMedia(media);  #3597
 				}
 				
 				//mimeType + suffix
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/validation/BerlinModelRefDetailImportValidator.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/validation/BerlinModelRefDetailImportValidator.java
index c8cbb64c8c..c2f5f45e15 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/validation/BerlinModelRefDetailImportValidator.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/berlinModel/in/validation/BerlinModelRefDetailImportValidator.java
@@ -15,6 +15,7 @@ import java.sql.SQLException;
 
 import org.apache.log4j.Logger;
 
+import eu.etaxonomy.cdm.database.update.DatabaseTypeNotSupportedException;
 import eu.etaxonomy.cdm.io.berlinModel.in.BerlinModelImportState;
 import eu.etaxonomy.cdm.io.common.IOValidator;
 import eu.etaxonomy.cdm.io.common.Source;
@@ -93,7 +94,7 @@ public class BerlinModelRefDetailImportValidator implements IOValidator<BerlinMo
 			
 		} catch (SQLException e) {
 			e.printStackTrace();
-		} catch (NoSuchMethodException e) {
+		} catch (DatabaseTypeNotSupportedException e) {
 			logger.debug("Source does not support checking existance of 'idInSource' column");
 		}
 		return success;
